image: node:6

cache:
  paths:
  - node_modules

stages:
  - init
  - commit_test
  - build
  - acceptance_test
  - deploy

npm_install:
  stage: init
  script: npm install
  artifacts:
    expire_in: 2 weeks
    paths:
      - node_modules

lint:
  stage: commit_test
  script: npm run lint

unit:
  stage: commit_test
  script: npm run test:unit
  artifacts:
    expire_in: 1 week
    paths:
      - coverage

commonjs:
  stage: build
  script: npm run build:cjs
  artifacts:
    expire_in: 1 week
    paths:
      - build

javascript:
  stage: build
  script: npm run build:js
  artifacts:
    expire_in: 1 week
    paths:
      - build

docs:
  stage: build
  script: npm run build:docs
  artifacts:
    expire_in: 1 week
    paths:
      - build

e2e:
  stage: acceptance_test
  script: npm test
  artifacts:
    expire_in: 1 week
    paths:
      - coverage

version:
  stage: deploy
  script:
    - git config --global user.email "tom@tomdavidson.org"
    - git config --global user.name "Tom D. Davidson"
    - git config --global push.default simple 
    - npm run version && git push --follow-tags
  only:
    - master
  except:
    - tags
  when: manual
  allow_failure: false

npm_publish:
  stage: deploy
  only:
    - tags
  script:
    - echo '//registry.npmjs.org/:_authToken=${NPM_TOKEN}'>.npmrc
    - npm publish
  except:
   - branches
  dependencies:
    - javascript
    - commonjs
    - docs

gitlab_release:
  variables:
    CONVENTIONAL_GITLAB_RELEASER_TOKEN: $CI_BUILD_TOKEN
  stage: deploy
  only:
    - tags
  script:
    - npm release
  except:
    - branches

pages:
  stage: deploy
  environment:
    name: GitLab Pages
    url: https://byu-oit-appdev.gitlab.io/handbook
  script:
    - mkdir public
    - mv build/docs public
    - mv coverage public/coverage
  artifacts:
    paths:
    - public
  only:
    - tags
    - triggers
  except:
   - branches
  dependencies:
    - e2e
    - docs
